import javax.swing.*;
import java.awt.*;
import java.util.*;
import javax.swing.Timer;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Color;

public class AudioProjectPanel extends JPanel {
	MouseListener mListener;
	Level nivel;
	ArrayList<Record> vowels;
	ArrayList<JPanel> vowelpanel;
	JLabel welcome, message, level;
	double recordtime = 1500;

	public AudioProjectPanel(){
		level = new JLabel();
		welcome = new JLabel("VowelMe");
		welcome.setHorizontalAlignment(SwingConstants.CENTER);
		welcome.setFont(new Font("Arial", Font.BOLD, 24));
		message = new JLabel("<html> \u2022 Para empezar a jugar vaya a Inicio->Comenzar <br> \u2022 Para ver como jugar haga click en Instrucciones </html>");
		message.setHorizontalAlignment(SwingConstants.CENTER);
		nivel = new Level(3);
		vowels = new ArrayList<Record>();
		vowelpanel = new ArrayList<JPanel>();
		setLayout(new BorderLayout());
		mListener = new MouseListener(this);
		setFocusable(true);
		addMouseMotionListener(mListener);
		addMouseListener(mListener);
		this.add(level, BorderLayout.PAGE_END);
		this.add(welcome, BorderLayout.PAGE_START);
		this.add(message, BorderLayout.CENTER);
	}

	public void enableMouseListener(){
		addMouseMotionListener(mListener);
		addMouseListener(mListener);
	}

	public void desableMouseListener(){
		removeMouseMotionListener(mListener);
		removeMouseListener(mListener);
	}

	public void begin(){
		System.out.println("Empezando Nivel");
		this.remove(level);
		this.remove(welcome);
		this.remove(message);
		if(nivel.getLives() == 0){
			nivel.resetLevel();
			nivel.LifeReset();
			nivel.resetAnswers();
		}
		level = new JLabel("<html> Vidas:" + nivel.getLives() + " <br> Nivel:" + nivel.getLevel() + " <br> Puntaje:" + nivel.getScore() + "</html>");
		level.setHorizontalAlignment(SwingConstants.CENTER);
		this.add(level, BorderLayout.NORTH);
		JPanel vp = new JPanel();
		vp.setBackground(Color.WHITE);
		Record rc = new Record();
		System.out.println("Limpiando Arraylist");
		removeVowels();
		nivel.resetScore();
		nivel.resetAnswers();
		for(int i = 0; i < nivel.getLevel(); i++){
			System.out.println("Creando record " + i+1);		
			double rand = Math.random();
			vowelpanel.add(vp);
			if(rand < 0.2)
				rc = new Record("A", recordtime, this);
			else if(rand>= 0.2 && rand <0.4)
				rc = new Record("E", recordtime, this);
			else if(rand>= 0.4 && rand <0.6)
				rc = new Record("I", recordtime, this);
			else if(rand>= 0.6 && rand <0.8)
				rc = new Record("O", recordtime, this);
			else if(rand>0.8)
				rc = new Record("U", recordtime, this);
			vowels.add(rc);
			vp.add(rc);
			this.add(vp, BorderLayout.CENTER);
		}
		System.out.println("Timer para memorizar");
		
		Timer t1 = new Timer(3000, new ActionListener(){
			public void actionPerformed(ActionEvent event){
				for(Record r : vowels){
					System.out.println(r.captB.getText());
					r.captB.setText("?");
					r.captB.setEnabled(true);
				}
			}
		});
		t1.setRepeats(false);
		t1.start();
		this.updateUI();
	}

	public void removeVowels(){
		for(JPanel vp : vowelpanel){
			this.remove(vp);
		}
		vowelpanel.clear();
		vowels.clear();
	}

	public void setRecordTime(double t){
		recordtime = t;
	}

	public void test(){

	}
}
