import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Scanner;
import java.io.*;

public class LPC {

	public static float[] xcorr(float[] sp_input, int p){
		/*
		 * RMS:			Promedio cuadrático medio de la señal (out)
		 * corr:		Autocorrelación de la señal (out)
		 * sp_input:	Señal de entrada (in)
		 * p:			Tamaño total de la ventana
		 */
		
		float[] corr = new float[p];
		short i;
		int j;
		int frameLength = 8000;
	
		for(i=0;i<p;i++){
			corr[i] = 0;
			for(j=0;j<frameLength-i;j++){
				//sp_input = (float) sp_input[j] / 32768.0;
				corr[i] = corr[i] + (sp_input[j] * sp_input[j+i]);
				//corr[i] = corr[i].plus(sp_input[j].times(sp_input[j+i]));
				
			}
			corr[i] = corr[i]/((float)frameLength);
		}
		//*RMS = (float) sqrt(corr[0]);
		return corr;
	}
	
	public static float[] levinson(float[] r, int order){
		int   i=1,j=1;
		float sum=0;
		short loop;
		float[] e = new float[order];
		float[] k = new float[order];
		float[] alpha = new float[order];
		float[] alpha_prev = new float[order];

		// Initialising the Array variables
		 for (loop=0;loop<order;loop++)
		 {
		  e[loop]=0;
		  k[loop]=0;
		  alpha[loop]=0;
		  alpha_prev[loop]=0;
		  }
		  // End initalising
		  e[0]=r[0];
		  // Iterate with i=1 to order as iteration variable
		  i=1;
		  for(i=1;i<=order-1;i++)
		  {
		  // start step 1
		  sum=0;
		  for (j=1;j<=i-1;j++)
		  sum+=alpha_prev[j]*r[i-j];
		  k[i]=(r[i]-sum)/e[i-1];
		  // End step 1
		  //start step 2
		  alpha[i]=k[i];
		  for(j=1;j<=i-1;j++)
		  alpha[j]=alpha_prev[j]- ( k[i]*alpha_prev[i-j] ) ;
		  //end step 2
		  //start step 3
			e[i]=e[i-1]*(1-(k[i]*k[i]));
		  //end step 3
		 for( loop=0;loop<order;loop++)
		 {
		  alpha_prev[loop]=alpha[loop];
		  }
		 }// End For levinson
		 for( loop=0;loop<order;loop++)
		 alpha[loop]=-1*alpha[loop];
		 alpha[0]=1;
		 
		 return(alpha);

	//static int order =15;
	}
	
	static float getLPC(float[] signal, int order, int index){
		float[] corr = new float[order];
		float[] lpc = new float[order];
		corr = xcorr(signal, order);
		lpc = levinson(corr, order);
		return lpc[index];
	}
}
